--
-- PostgreSQL database dump
--

-- Dumped from database version 12.9
-- Dumped by pg_dump version 14.1 (Debian 14.1-1.pgdg110+1)

-- Started on 2021-11-19 06:49:14 +05

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

DROP DATABASE "test";
--
-- TOC entry 2860 (class 1262 OID 1487459)
-- Name: test; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE "test" WITH TEMPLATE = template0 ENCODING = 'UTF8' LOCALE = 'ru_RU.UTF-8';


\connect "test"

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- TOC entry 647 (class 1247 OID 1487566)
-- Name: cc; Type: TYPE; Schema: public; Owner: -
--

CREATE TYPE "public"."cc" AS (
	"id" integer,
	"id_a" integer,
	"ca" "text",
	"cb" "text",
	"cd" "text",
	"sort" integer
);


SET default_table_access_method = "heap";

--
-- TOC entry 205 (class 1259 OID 1487479)
-- Name: c; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE "public"."c" (
    "id" integer NOT NULL,
    "id_a" integer NOT NULL,
    "ca" "text",
    "cb" "text",
    "cd" "text",
    "sort" integer
);


--
-- TOC entry 207 (class 1259 OID 1487524)
-- Name: vc; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW "public"."vc" AS
 SELECT "c"."id",
    "c"."id_a",
    "c"."ca",
    "c"."cb",
    "c"."cd",
    "c"."sort"
   FROM "public"."c";


--
-- TOC entry 211 (class 1255 OID 1487567)
-- Name: int_cast_vc_to_cc("public"."vc"); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION "public"."int_cast_vc_to_cc"("ivc" "public"."vc") RETURNS "public"."cc"
    LANGUAGE "plpgsql" IMMUTABLE PARALLEL SAFE
    AS $$
DECLARE
 result  cc%ROWTYPE;
BEGIN
     result = ivc;
     RETURN result;
END;
$$;


--
-- TOC entry 202 (class 1259 OID 1487460)
-- Name: a; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE "public"."a" (
    "aa" "text",
    "ab" "text",
    "ac" "text",
    "id" integer NOT NULL
);


--
-- TOC entry 209 (class 1259 OID 1487569)
-- Name: int_a_ext; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW "public"."int_a_ext" AS
 SELECT "cp"."id_a" AS "id",
    "array_agg"(("cp".*)::"public"."cc" ORDER BY "cp"."sort") AS "cc_list"
   FROM "public"."vc" "cp"
  GROUP BY "cp"."id_a";


--
-- TOC entry 210 (class 1259 OID 1487573)
-- Name: va_ext; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW "public"."va_ext" AS
 SELECT "a"."id",
    "a"."aa",
    "a"."ab",
    "a"."ac",
    "cc"."cc_list"
   FROM ("public"."a"
     JOIN "public"."int_a_ext" "cc" ON (("cc"."id" = "a"."id")));


--
-- TOC entry 212 (class 1255 OID 1487578)
-- Name: a_ext_by_id(bigint); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION "public"."a_ext_by_id"("iid" bigint) RETURNS SETOF "public"."va_ext"
    LANGUAGE "sql" STABLE SECURITY DEFINER ROWS 1 PARALLEL SAFE
    AS $$
    SELECT * FROM va_ext WHERE "id" = iid;
$$;


--
-- TOC entry 2717 (class 2605 OID 1487568)
-- Name: CAST ("public"."vc" AS "public"."cc"); Type: CAST; Schema: -; Owner: -
--

CREATE CAST ("public"."vc" AS "public"."cc") WITH FUNCTION "public"."int_cast_vc_to_cc"("public"."vc");


--
-- TOC entry 203 (class 1259 OID 1487466)
-- Name: a_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE "public"."a_id_seq"
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 2861 (class 0 OID 0)
-- Dependencies: 203
-- Name: a_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE "public"."a_id_seq" OWNED BY "public"."a"."id";


--
-- TOC entry 204 (class 1259 OID 1487477)
-- Name: c_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE "public"."c_id_seq"
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 2862 (class 0 OID 0)
-- Dependencies: 204
-- Name: c_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE "public"."c_id_seq" OWNED BY "public"."c"."id";


--
-- TOC entry 206 (class 1259 OID 1487520)
-- Name: va; Type: VIEW; Schema: public; Owner: -
--

CREATE VIEW "public"."va" AS
 SELECT "a"."id",
    "a"."aa",
    "a"."ab",
    "a"."ac"
   FROM "public"."a";


--
-- TOC entry 2718 (class 2604 OID 1487468)
-- Name: a id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY "public"."a" ALTER COLUMN "id" SET DEFAULT "nextval"('"public"."a_id_seq"'::"regclass");


--
-- TOC entry 2719 (class 2604 OID 1487482)
-- Name: c id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY "public"."c" ALTER COLUMN "id" SET DEFAULT "nextval"('"public"."c_id_seq"'::"regclass");


--
-- TOC entry 2723 (class 2606 OID 1487487)
-- Name: c c_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY "public"."c"
    ADD CONSTRAINT "c_pkey" PRIMARY KEY ("id_a");


--
-- TOC entry 2721 (class 2606 OID 1487476)
-- Name: a pk_a; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY "public"."a"
    ADD CONSTRAINT "pk_a" PRIMARY KEY ("id");


--
-- TOC entry 2724 (class 2606 OID 1487488)
-- Name: c fk_a_c; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY "public"."c"
    ADD CONSTRAINT "fk_a_c" FOREIGN KEY ("id_a") REFERENCES "public"."a"("id") NOT VALID;


-- Completed on 2021-11-19 06:49:15 +05

--
-- PostgreSQL database dump complete
--

